local appname = "Broker_Repa"

local AceLocale = LibStub("AceLocale-3.0")
local L = AceLocale:GetLocale( "Broker_Repa" )

local Broker_Repa  = CreateFrame("Frame","Broker_Repa")
local app = LibStub("AceAddon-3.0"):NewAddon("Broker_Repa","AceEvent-3.0")
app.revision = tonumber(string.sub("$Revision: 24 $", 12, -3))
app.version = "v3.3.0-r" .. app.revision
local realmName = GetRealmName()
	
local sName, title, sNotes, enabled, loadable, reason, security = GetAddOnInfo("Broker_Repa")

local ldb = LibStub:GetLibrary("LibDataBroker-1.1",true)
local dataobj
local tooltip = LibStub("LibQTip-1.0")

local tt
--app.version = GetAddOnMetadata(appname,"Version") or '0.0'

dataobj = ldb:NewDataObject("Repa", {
	type = "data source",
	label = "Repa",
	icon = "Interface\\AddOns\\Broker_Repa\\icon.tga",
	text = "Repa",
	OnClick = function(clickedframe, button)
		if (button == "RightButton") then
			InterfaceOptionsFrame_OpenToCategory(Broker_Repa.menu)
		end
	end,

	OnEnter = OnEnter,
	OnLeave = OnLeave,
})

function Broker_Repa.InitializeSettings()
	self = Broker_Repa
	if (not Broker_RepaConfig) then
		Broker_RepaConfig = {
		order = "1",
		field = "1",
		check="1",
		filter={
			true,true,true,true,true,true,true,true,
		},
        }
	end
	if not Broker_RepaDB or not Broker_RepaDB.realm then
		Broker_RepaDB = {			
			realm = {},
		}
	end
	if not Broker_RepaDB.realm[realmName] then
		Broker_RepaDB.realm[realmName] = {}
	end

	dataobj.UpdateText()
end
Broker_Repa.options = 	{
type = 'group',
	args = {
		gsort = {
			type = "group",
			name = L["Sort"],
			desc = L["Sorting_Type"],
			args = {
				sorters = {
					type = "select",
					name = L["Order"],
					desc = L["Order"],
					get = function() return Broker_RepaConfig.order end,
					set = function(_,v) Broker_RepaConfig.order = v end,
					values = {
						["0"]=L["None"],
						["1"]=L["Asc"],
						["2"]=L["Desc"]
					},
				},
				fields = {
					type = "select",
					name = L["Field"],
					desc = L["Field"],
					get = function() return Broker_RepaConfig.field end,
					set = function(_,v) Broker_RepaConfig.field = v end,
					values= {
						["0"]=L["Factions"],
						["1"]=L["Reputation"],
						["2"]=L["Left"]
					},
				},
			},
		},
		grepa={
			type="group",
			name=L["Reputation"],
			desc=L["Reputation"],
			args={
				 Hated={
					type = "toggle",
					name = L["Hated"],
					desc = L["Hated"],
					get = function() return Broker_RepaConfig.filter[1]; end,
					set = function(_,v) Broker_RepaConfig.filter[1]= v; end,
				 },
				 Hostile={
					type = "toggle",
					name = L["Hostile"],
					desc = L["Hostile"],
					get = function() return Broker_RepaConfig.filter[2]; end,
					set = function(_,v) Broker_RepaConfig.filter[2]= v; end,
				 },
				 Unfriendly={
					type = "toggle",
					name = L["Unfriendly"],
					desc = L["Unfriendly"],
					get = function() return Broker_RepaConfig.filter[3]; end,
					set = function(_,v) Broker_RepaConfig.filter[3]= v; end,				 
				},
				 Neutral={
					type = "toggle",
					name = L["Neutral"],
					desc = L["Neutral"],
					get = function() return Broker_RepaConfig.filter[4]; end,
					set = function(_,v) Broker_RepaConfig.filter[4] = v; end,				 
				},
				 Friendly={
					type = "toggle",
					name = L["Friendly"],
					desc = L["Friendly"],
					get = function() return Broker_RepaConfig.filter[5]; end,
					set = function(_,v) Broker_RepaConfig.filter[5] = v; end,				 
				},
				 Honored={
					type = "toggle",
					name = L["Honored"],
					desc = L["Honored"],
					get = function() return Broker_RepaConfig.filter[6]; end,
					set = function(_,v) Broker_RepaConfig.filter[6]= v; end,				 
				},
				 Revered ={
					type = "toggle",
					name = L["Revered"],
					desc = L["Revered"],
					get = function() return Broker_RepaConfig.filter[7]; end,
					set = function(_,v) Broker_RepaConfig.filter[7]= v; end,				 
				},
				 Exalted={
					type = "toggle",
					name = L["Exalted"],
					desc = L["Exalted"],
					get = function() return Broker_RepaConfig.filter[8]; end,
					set = function(_,v) Broker_RepaConfig.filter[8] = v; end,				 
				},
			},
		},
	},
}




local AceCfgReg = LibStub("AceConfigRegistry-3.0")
local AceCfg = LibStub("AceConfig-3.0")
local brokenOptions = AceCfgReg:GetOptionsTable("Broker", "dialog", "LibDataBroker-1.1")
if (not brokerOptions) then
	brokerOptions = {
		type = "group",
		name = "Broker",
		args = {
		}
	}
--	AceCfg:RegisterOptionsTable("Broker_Repa", brokerOptions)
--	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Repa", "Broker Repa")
end
AceCfg:RegisterOptionsTable("Broker_Repa", Broker_Repa.options)
Broker_Repa.menu = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Repa", sName, "Broker")

function app:OnInitialize()
	Broker_Repa.InitializeSettings()
	app:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
end
--local function hidem()
--	print("1")
--	if tt and not MouseIsOver(tt) then
--		tooltip:Release(tt)
--		tt:SetScript("OnLeave", nil)
--		tt=nil
--	end
--end
--function dataobj.OnEnter(self)
--print("2")
--end
function dataobj.OnEnter(ssd)
	local t={}
	tt = tooltip:Acquire("Broker_Repa", 3, "CENTER","CENTER","CENTER")
	tt:SetAutoHideDelay(1)
	tt:EnableMouse(true)
--	tt:SetScript("OnLeave", hidem)
	tt:SmartAnchorTo(ssd)
	tt:Clear()
	tt:SetScale(1)
	tt:SetBackdropBorderColor(1, 1, 1, 1)
	tt:Show()
	tt:AddLine(" ")
	tt:AddHeader("|cFFFF0000"..L["Factions"],"|cFFFF0000"..L["Reputation"],"|cFFFF0000"..L["Left"])
	tt:SetColumnLayout(3,"LEFT","RIGHT","RIGHT")
	for i=1,GetNumFactions() do
		local fname, _, standingId,bottomValue,topValue, earnedValue,_,_, isHeader,_,_,_,_ = GetFactionInfo(i)
		local tmptxt=(earnedValue-bottomValue).."/"..(topValue-bottomValue)
		if isHeader==nil then
			if Broker_RepaConfig.filter[standingId]==true then
				table.insert(t,{a=i,b=earnedValue,c=bottomValue,d=topValue,e=fname})
			end
		end
	end
	table.sort(t, function (a, b) 
		if (Broker_RepaConfig.order=="0") then
			return false 
		elseif (Broker_RepaConfig.order=="1") then 
			if (Broker_RepaConfig.field=="0") then
				return a.e<b.e
			elseif (Broker_RepaConfig.field=="1") then
				return a.b<b.b 
			elseif (Broker_RepaConfig.field=="2") then
				return (a.d-a.b)<(b.d-b.b)
			end
		elseif (Broker_RepaConfig.order=="2") then 
			if (Broker_RepaConfig.field=="0") then
				return a.e>b.e
			elseif (Broker_RepaConfig.field=="1") then
				return a.b>b.b 
			elseif (Broker_RepaConfig.field=="2") then
				return (a.d-a.b)>(b.d-b.b)
			end
		end 
	end)

	for _, data in ipairs(t) do
		local clr
		clr="|cFFFFD500"
		if ((data.d-data.c)==3000) then
			clr="|cFFFFFF00"
		elseif ((data.d-data.c)==6000) then
			clr="|cFF007F00"
		elseif ((data.d-data.c)==12000) then
			clr="|cFF00FF00"
		elseif ((data.d-data.c)==21000) then
			clr="|cFFE6CC7F"
			elseif ((data.d-data.c)==36000) then
			clr="|cFFFF0000"
		end

		local line=tt:AddLine("|cFFFFD500"..data.e,clr..(data.b-data.c).."/"..(data.d-data.c),"|cFFFFD500"..(data.d-data.b))
		tt:SetLineScript(line, "OnMouseDown", function(_,ttd) Broker_RepaConfig.check=ttd dataobj.UpdateText() end,data.a)
		--		tt:SetCell(line,1,"|cFFFFD500"..data.e)
--		tt:SetCell(line,2,clr..(data.b-data.c).."/"..(data.d-data.c))
--		tt:SetCell(line,3,"|cFFFFD500"..(data.d-data.b))
	end
	tt:UpdateScrolling(400)
--	tt=nil


end
function dataobj.OnLeave(ssd)
--	tooltip:Release(tt)
--	tt=nil
end
function dataobj.UpdateText()
	local _, _, _,bottomValue,topValue, earnedValue,_,_, isHeader,_,_,_,_ = GetFactionInfo(Broker_RepaConfig.check)
	if isHeader==nil then
		if earnedValue~=nil then
			dataobj.text=(earnedValue-bottomValue).."/"..(topValue-bottomValue)
		else
			dataobj.text="Repa"
		end
	else
		dataobj.text="Repa"
	end

end
function app:CHAT_MSG_COMBAT_FACTION_CHANGE()
dataobj:UpdateText()
end